pro createHDFFile,outname,reflWater, reflIce,angs,ag, rew,rei,tau, wvl,LAND=land,OCEAN=ocean
;;;
;;angs =[solar, view,azm]
solar=angs[0]
view=angs[1]
azm=angs[2]
scaleFactor = 1.D0
HD_ID = HDF_OPEN(outname, /ALL) ; Create a new HDF file.
FILE_ID = HDF_SD_START(outname, /RDWR) ; Start the SD interface.
if(KEYWORD_SET(land))then begin
HDF_SD_ATTRSET, FILE_ID, 'TITLE', 'TOA REFLECTANCE OVER LAND', 26
HDF_SD_ATTRSET, FILE_ID, 'SURFACE_ALBEDO',ag, /FLOAT
endif
if(KEYWORD_SET(ocean))then begin
HDF_SD_ATTRSET, FILE_ID, 'TITLE', 'TOA REFLECTANCE OVER OCEAN', 27
HDF_SD_ATTRSET, FILE_ID, 'WIND_SPEED',ag, /FLOAT
HDF_SD_ATTRSET, FILE_ID, 'WIND_SPEED_UNITS','m/s', 3
endif


HDF_SD_ATTRSET, FILE_ID, 'SOLARANG',solar, /FLOAT
HDF_SD_ATTRSET, FILE_ID, 'VIEWANG',view, /FLOAT
HDF_SD_ATTRSET, FILE_ID, 'AZMANG',azm, /FLOAT
HDF_SD_ATTRSET, FILE_ID, 'CREATION_DATE',systime()

s = SIZE(reflWater)

SDS_ID = HDF_SD_CREATE(FILE_ID, "reflectanceWater", [s[1],s[2],s[3]], /FLOAT)
dimid = HDF_SD_DIMGETID(SDS_ID,0)
HDF_SD_DIMSET,dimid,NAME='NumOfCOT'
dimid = HDF_SD_DIMGETID(SDS_ID,1)
HDF_SD_DIMSET,dimid,NAME='NumOfWvl'
dimid = HDF_SD_DIMGETID(SDS_ID,2)
HDF_SD_DIMSET,dimid,NAME='NumOfRE_Water'
reflWater[*,s[2]-1,*]=-9999.0
HDF_SD_ADDDATA, SDS_ID, reflWater


HDF_SD_AttrSet,SDS_ID, 'Scale_Factor',scaleFactor,/DOUBLE

if(KEYWORD_SET(land))then HDF_SD_AttrSet, SDS_ID, 'Discription', 'Lambertian Water C6 Reflectance'
if(KEYWORD_SET(ocean))then HDF_SD_AttrSet, SDS_ID, 'Discription', 'Ocean Water C6 Reflectance'

HDF_SD_ENDACCESS, SDS_ID

SDS_ID = HDF_SD_CREATE(FILE_ID, "ParticleRadiusWater", [s[3]], /FLOAT)
HDF_SD_ADDDATA, SDS_ID, rew
HDF_SD_AttrSet,SDS_ID, 'Scale_Factor',scaleFactor,/DOUBLE
HDF_SD_AttrSet, SDS_ID, 'Discription', 'Effective Radii for water'
HDF_SD_AttrSet, SDS_ID, 'Units', 'microns'
HDF_SD_ENDACCESS, SDS_ID


s = SIZE(reflIce)

SDS_ID = HDF_SD_CREATE(FILE_ID, "reflectanceIce", [s[1],s[2],s[3]], /FLOAT)
dimid = HDF_SD_DIMGETID(SDS_ID,0)
HDF_SD_DIMSET,dimid,NAME='NumOfCOT'
dimid = HDF_SD_DIMGETID(SDS_ID,1)
HDF_SD_DIMSET,dimid,NAME='NumOfWvl'
dimid = HDF_SD_DIMGETID(SDS_ID,2)
HDF_SD_DIMSET,dimid,NAME='NumOfRE_Ice'
reflIce[*,s[2]-1,*]=-9999.0

HDF_SD_ADDDATA, SDS_ID, reflIce
HDF_SD_AttrSet,SDS_ID, 'Scale_Factor',scaleFactor,/DOUBLE
if(KEYWORD_SET(land))then HDF_SD_AttrSet, SDS_ID, 'Discription', 'Lambertian Ice C6 Reflectance'
if(KEYWORD_SET(ocean))then HDF_SD_AttrSet, SDS_ID, 'Discription', 'Ocean Ice C6 Reflectance'

HDF_SD_ENDACCESS, SDS_ID

SDS_ID = HDF_SD_CREATE(FILE_ID, "ParticleRadiusIce", [s[3]], /FLOAT)
HDF_SD_ADDDATA, SDS_ID, rei
HDF_SD_AttrSet,SDS_ID, 'Scale_Factor',scaleFactor,/DOUBLE
HDF_SD_AttrSet, SDS_ID, 'Discription', 'Effective Radii for ice'
HDF_SD_AttrSet, SDS_ID, 'Units', 'microns'
HDF_SD_ENDACCESS, SDS_ID

SDS_ID = HDF_SD_CREATE(FILE_ID, "WaveLengths", [s[2]], /FLOAT)
HDF_SD_ADDDATA, SDS_ID, wvl
HDF_SD_AttrSet,SDS_ID, 'Scale_Factor',scaleFactor,/DOUBLE
HDF_SD_AttrSet, SDS_ID, 'Discription', 'Wavelengths LUT'
HDF_SD_AttrSet, SDS_ID, 'Units', 'microns'
HDF_SD_ENDACCESS, SDS_ID

SDS_ID = HDF_SD_CREATE(FILE_ID, "OpticalThickness", [s[1]], /FLOAT)
HDF_SD_ADDDATA, SDS_ID, tau
HDF_SD_AttrSet,SDS_ID, 'Scale_Factor',scaleFactor,/DOUBLE
HDF_SD_AttrSet, SDS_ID, 'Discription', 'COT LUT'
HDF_SD_AttrSet, SDS_ID, 'Units', 'none'
HDF_SD_ENDACCESS, SDS_ID

HDF_SD_END, FILE_ID
HDF_CLOSE, HD_ID

end



